local spamFilterMatch1 = string.gsub(ERR_LEARN_ABILITY_S:gsub('%.', '%.'), '%%s', '(.*)')
local spamFilterMatch2 = string.gsub(ERR_LEARN_SPELL_S:gsub('%.', '%.'), '%%s', '(.*)')
local spamFilterMatch3 = string.gsub(ERR_SPELL_UNLEARNED_S:gsub('%.', '%.'), '%%s', '(.*)')
local spamFilterMatch4 = string.gsub(ERR_LEARN_PASSIVE_S:gsub('%.', '%.'), '%%s', '(.*)')
local petFilterMatch1 = string.gsub(ERR_PET_SPELL_UNLEARNED_S:gsub('%.', '%.'), '%%s', '(.*)')
local petFilterMatch2 = string.gsub(ERR_PET_LEARN_ABILITY_S:gsub('%.', '%.'), '%%s', '(.*)')
local petFilterMatch3 = string.gsub(ERR_PET_LEARN_SPELL_S:gsub('%.', '%.'), '%%s', '(.*)')
local primarySpecSpellName = GetSpellInfo(63645)
local secondarySpecSpellName = GetSpellInfo(63644)

local HideSpam = CreateFrame("Frame");
HideSpam:RegisterEvent("UNIT_SPELLCAST_START");
HideSpam:RegisterEvent("UNIT_SPELLCAST_STOP");
HideSpam:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED");
HideSpam:RegisterEvent("PLAYER_LOGIN");

HideSpam.filter = function(self, event, msg, ...)
	if strfind(msg, spamFilterMatch1) then
		return true
	elseif strfind(msg, spamFilterMatch2) then
		return true
	elseif strfind(msg, spamFilterMatch3) then
		return true
	elseif strfind(msg, spamFilterMatch4) then
		return true
	end
	return false, msg, ...
end

HideSpam.Petfilter = function(self, event, msg, ...)
	if strfind(msg, petFilterMatch1) then
		return true
	elseif strfind(msg, petFilterMatch2) then
		return true
	elseif strfind(msg, petFilterMatch3) then
		return true
	end
	return false, msg, ...
end

HideSpam:SetScript("OnEvent", function( self, event, ...)

	local unit, spellName = ...

	if event == "PLAYER_LOGIN" then
		self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		self:RegisterEvent("PET_SPECIALIZATION_CHANGED")

	elseif(event == "UNIT_SPELLCAST_START") then
		if unit == "player" and (spellName == primarySpecSpellName or spellName == secondarySpecSpellName) then
			ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", self.filter)
		end
	
	elseif(event == "UNIT_SPELLCAST_STOP") or (event == "UNIT_SPELLCAST_INTERRUPTED") then
		if unit == "player" and (spellName == primarySpecSpellName or spellName == secondarySpecSpellName) then
			ChatFrame_RemoveMessageEventFilter("CHAT_MSG_SYSTEM", self.filter)
		end

	elseif(event == "ACTIVE_TALENT_GROUP_CHANGED") then
		local specId = GetSpecialization(false, false, group);
		if (specId == nil) then
			print("Switched to an empty spec.")
		else
			local _, spec, _, icon = GetSpecializationInfo(specId, false, false);
			print("Switched to  |T".. icon ..":0|t |cff6adb54".. spec .."|r spec.")
		end

	elseif(event == "PET_SPECIALIZATION_CHANGED") then
		ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", self.Petfilter)
	end

end);